--- u-boot-2011.06_original/arch/arm/lib/cache-cp15.c	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/arch/arm/lib/cache-cp15.c	2014-10-30 20:54:29.112101000 +0800
@@ -2,38 +2,28 @@
  * (C) Copyright 2002
  * Wolfgang Denk, DENX Software Engineering, wd@denx.de.
  *
- * See file CREDITS for list of people who contributed to this
- * project.
- *
- * This program is free software; you can redistribute it and/or
- * modify it under the terms of the GNU General Public License as
- * published by the Free Software Foundation; either version 2 of
- * the License, or (at your option) any later version.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
- * MA 02111-1307 USA
+ * SPDX-License-Identifier:	GPL-2.0+
  */
 
 #include <common.h>
 #include <asm/system.h>
+#include <asm/cache.h>
+#include <linux/compiler.h>
 
-#if !(defined(CONFIG_SYS_NO_ICACHE) && defined(CONFIG_SYS_NO_DCACHE))
-
-#if defined(CONFIG_SYS_ARM_CACHE_WRITETHROUGH)
-#define CACHE_SETUP	0x1a
-#else
-#define CACHE_SETUP	0x1e
-#endif
+#if !(defined(CONFIG_SYS_ICACHE_OFF) && defined(CONFIG_SYS_DCACHE_OFF))
 
 DECLARE_GLOBAL_DATA_PTR;
 
+void __arm_init_before_mmu(void)
+{
+}
+void arm_init_before_mmu(void)
+	__attribute__((weak, alias("__arm_init_before_mmu")));
+
+__weak void arm_init_domains(void)
+{
+}
+
 static void cp_delay (void)
 {
 	volatile int i;
@@ -44,9 +34,41 @@
 	asm volatile("" : : : "memory");
 }
 
-static inline void dram_bank_mmu_setup(int bank)
+void set_section_dcache(int section, enum dcache_option option)
+{
+	u32 *page_table = (u32 *)gd->tlb_addr;
+	u32 value;
+
+	value = (section << MMU_SECTION_SHIFT) | (3 << 10);
+	value |= option;
+	page_table[section] = value;
+}
+
+void __mmu_page_table_flush(unsigned long start, unsigned long stop)
+{
+	debug("%s: Warning: not implemented\n", __func__);
+}
+
+void mmu_page_table_flush(unsigned long start, unsigned long stop)
+	__attribute__((weak, alias("__mmu_page_table_flush")));
+
+void mmu_set_region_dcache_behaviour(u32 start, int size,
+				     enum dcache_option option)
 {
 	u32 *page_table = (u32 *)gd->tlb_addr;
+	u32 upto, end;
+
+	end = ALIGN(start + size, MMU_SECTION_SIZE) >> MMU_SECTION_SHIFT;
+	start = start >> MMU_SECTION_SHIFT;
+	debug("%s: start=%x, size=%x, option=%d\n", __func__, start, size,
+	      option);
+	for (upto = start; upto < end; upto++)
+		set_section_dcache(upto, option);
+	mmu_page_table_flush((u32)&page_table[start], (u32)&page_table[end]);
+}
+
+__weak void dram_bank_mmu_setup(int bank)
+{
 	bd_t *bd = gd->bd;
 	int	i;
 
@@ -54,20 +76,35 @@
 	for (i = bd->bi_dram[bank].start >> 20;
 	     i < (bd->bi_dram[bank].start + bd->bi_dram[bank].size) >> 20;
 	     i++) {
-		page_table[i] = i << 20 | (3 << 10) | CACHE_SETUP;
+#if defined(CONFIG_SYS_ARM_CACHE_WRITETHROUGH)
+		set_section_dcache(i, DCACHE_WRITETHROUGH);
+#else
+		set_section_dcache(i, DCACHE_WRITEBACK);
+#endif
+	}
+#ifdef DDR_SIZE_512M
+	for (i = (0x10000000 >> 20);
+	     i < (0x20000000 >> 20);
+	     i++) {
+#if defined(CONFIG_SYS_ARM_CACHE_WRITETHROUGH)
+        set_section_dcache(i, DCACHE_WRITETHROUGH);
+#else
+        set_section_dcache(i, DCACHE_WRITEBACK);
+#endif
 	}
+#endif
 }
 
 /* to activate the MMU we need to set up virtual memory: use 1M areas */
 static inline void mmu_setup(void)
 {
-	u32 *page_table = (u32 *)gd->tlb_addr;
 	int i;
 	u32 reg;
 
+	arm_init_before_mmu();
 	/* Set up an identity-mapping for all 4GB, rw for everyone */
 	for (i = 0; i < 4096; i++)
-		page_table[i] = i << 20 | (3 << 10) | 0x12;
+		set_section_dcache(i, DCACHE_OFF);
 
 	for (i = 0; i < CONFIG_NR_DRAM_BANKS; i++) {
 		dram_bank_mmu_setup(i);
@@ -75,23 +112,31 @@
 
 	/* Copy the page table address to cp15 */
 	asm volatile("mcr p15, 0, %0, c2, c0, 0"
-		     : : "r" (page_table) : "memory");
+		     : : "r" (gd->tlb_addr) : "memory");
 	/* Set the access control to all-supervisor */
 	asm volatile("mcr p15, 0, %0, c3, c0, 0"
 		     : : "r" (~0));
+
+	arm_init_domains();
+
 	/* and enable the mmu */
 	reg = get_cr();	/* get control reg. */
 	cp_delay();
 	set_cr(reg | CR_M);
 }
 
+static int mmu_enabled(void)
+{
+	return get_cr() & CR_M;
+}
+
 /* cache_bit must be either CR_I or CR_C */
 static void cache_enable(uint32_t cache_bit)
 {
 	uint32_t reg;
 
 	/* The data cache is not active unless the mmu is enabled too */
-	if (cache_bit == CR_C)
+	if ((cache_bit == CR_C) && !mmu_enabled())
 		mmu_setup();
 	reg = get_cr();	/* get control reg. */
 	cp_delay();
@@ -103,22 +148,25 @@
 {
 	uint32_t reg;
 
+	reg = get_cr();
+	cp_delay();
+
 	if (cache_bit == CR_C) {
 		/* if cache isn;t enabled no need to disable */
-		reg = get_cr();
 		if ((reg & CR_C) != CR_C)
 			return;
 		/* if disabling data cache, disable mmu too */
 		cache_bit |= CR_M;
-		flush_cache(0, ~0);
 	}
 	reg = get_cr();
 	cp_delay();
+	if (cache_bit == (CR_C | CR_M))
+		flush_dcache_all();
 	set_cr(reg & ~cache_bit);
 }
 #endif
 
-#ifdef CONFIG_SYS_NO_ICACHE
+#ifdef CONFIG_SYS_ICACHE_OFF
 void icache_enable (void)
 {
 	return;
@@ -150,7 +198,7 @@
 }
 #endif
 
-#ifdef CONFIG_SYS_NO_DCACHE
+#ifdef CONFIG_SYS_DCACHE_OFF
 void dcache_enable (void)
 {
 	return;
diff '--exclude=.svn' -Naur u-boot-2011.06_original/arch/arm/lib/interrupts.c u-boot-2011.06/arch/arm/lib/interrupts.c
--- u-boot-2011.06_original/arch/arm/lib/interrupts.c	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/arch/arm/lib/interrupts.c	2014-07-29 17:28:38.819972000 +0800
@@ -51,6 +51,7 @@
 	FIQ_STACK_START = IRQ_STACK_START - CONFIG_STACKSIZE_IRQ;
 
 	return arch_interrupt_init();
+	return 0;
 }
 
 /* enable IRQ interrupts */
diff '--exclude=.svn' -Naur u-boot-2011.06_original/board/cavium/cnc1900/auto_update_1900.c u-boot-2011.06/board/cavium/cnc1900/auto_update_1900.c
--- u-boot-2011.06_original/board/cavium/cnc1900/auto_update_1900.c	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/board/cavium/cnc1900/auto_update_1900.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,625 @@
+/*
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of
+ * the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
+ * MA 02111-1307 USA
+ */
+#include <common.h>
+#include <command.h>
+#include <malloc.h>
+#include <image.h>
+#include <asm/byteorder.h>
+#include <usb.h>
+
+#include <jffs2/jffs2.h>
+#include <nand.h>
+//#include <cnc1800l_spi.h>
+
+#ifdef CONFIG_SYS_HUSH_PARSER
+#include <hush.h>
+#endif
+
+
+#ifdef CONFIG_AUTO_UPDATE
+
+#if 0
+#ifndef CONFIG_USB_OHCI_NEW
+#error "must define CONFIG_USB_OHCI"
+#endif
+
+#ifndef CONFIG_USB_STORAGE
+#error "must define CONFIG_USB_STORAGE"
+#endif
+
+#ifndef CONFIG_CMD_FAT
+#error "must define CONFIG_CMD_FAT"
+#endif
+#endif
+
+#undef AU_DEBUG
+
+#undef debug
+#ifdef	AU_DEBUG
+#define debug(fmt,args...)	printf (fmt ,##args)
+#else
+#define debug(fmt,args...)
+#endif	/* AU_DEBUG */
+
+/* possible names of files on the USB stick. */
+#define AU_FIRMWARE	"u-boot.img"
+#define AU_KERNEL	"uimage"
+#define AU_RAMDISK	"ramdisk.img"
+static  char *filename = "misc.img";
+//#define RESET_AFTER_USB_UPGRADE
+
+struct flash_layout {
+	long start;
+	long end;
+};
+
+unsigned int bootargs_len = 0;
+unsigned int bootcmd_len = 0;
+
+static int au_usb_stor_curr_dev; /* current device */
+
+/* index of each file in the following arrays */
+#define IDX_FIRMWARE	0
+#define IDX_KERNEL	1
+#define IDX_RAMDISK	2
+
+/* max. number of files which could interest us */
+#define AU_MAXFILES 3
+
+#define BOOT_START	0x34400000
+
+/* pointers to file names */
+char *aufile[AU_MAXFILES];
+
+/* sizes of flash areas for each file */
+long ausize[AU_MAXFILES];
+
+/* the index table of the file type */
+int autype[AU_MAXFILES] = { \
+	IH_TYPE_FIRMWARE, IH_TYPE_KERNEL, IH_TYPE_RAMDISK};
+
+/* the index table of the OS type */
+int ostype[AU_MAXFILES] = { \
+	IH_OS_LINUX, IH_OS_LINUX, IH_OS_LINUX}; //Reduce the probability of ramdom while we only upgrade uboot. --leiyu,2011.12.13
+
+/* array of flash areas start and end addresses */
+struct flash_layout aufl_layout[AU_MAXFILES]={{0}};
+
+#define VALID_ADDR 	(CONFIG_USB_UPGRADE_DATA_ADDR + 4 + bootargs_len + bootcmd_len + 48)
+
+/* externals */
+extern int fat_register_device(block_dev_desc_t *, int);
+extern int file_fat_detectfs(void);
+extern long file_fat_read(const char *, void *, unsigned long);
+//extern int i2c_read (unsigned char, unsigned int, int , unsigned char* , int);
+extern int flash_sect_erase(ulong, ulong);
+extern int flash_sect_protect (int, ulong, ulong);
+extern int flash_write (char *, ulong, ulong);
+/* change char* to void* to shutup the compiler */
+extern block_dev_desc_t *get_dev (const char*, int);
+extern int u_boot_hush_start(void);
+extern int do_sflasher(cmd_tbl_t * cmdtp, int flag, int argc, char * const argv[]);
+extern int do_sflashre(cmd_tbl_t * cmdtp, int flag, int argc, char * const argv[]);
+extern int do_usb(cmd_tbl_t * cmdtp, int flag, int argc, char * const argv[]);
+extern int do_fat_fsload(cmd_tbl_t * cmdtp, int flag, int argc, char * const argv[]);
+extern int do_call_external_proc(cmd_tbl_t * cmdtp, int flag, int argc, char * const argv[]);
+extern int do_cncflash(cmd_tbl_t * cmdtp, int flag, int argc, char * const argv[]);
+extern int do_sflashwr(cmd_tbl_t * cmdtp, int flag, int argc, char * const argv[]);
+extern int do_nand(cmd_tbl_t * cmdtp, int flag, int argc, char * const argv[]);
+extern int do_mem_md(cmd_tbl_t * cmdtp, int flag, int argc, char * const argv[]); 
+extern int do_flerase(cmd_tbl_t * cmdtp, int flag, int argc, char * const argv[]); 
+extern int do_mem_cmp(cmd_tbl_t * cmdtp, int flag, int argc, char * const argv[]); 
+extern int do_mem_cp(cmd_tbl_t * cmdtp, int flag, int argc, char * const argv[]); 
+
+int au_check_cksum_valid(long nbytes)
+{
+	image_header_t *hdr;
+	unsigned long checksum;
+
+	hdr = (image_header_t *)(VALID_ADDR);
+
+	/* check the data CRC */
+	checksum = ntohl(hdr->ih_dcrc);
+
+	if (crc32 (0, (uchar *)(VALID_ADDR + sizeof(*hdr)), ntohl(hdr->ih_size)) != checksum) {
+		printf ("usb upgrade file bad data checksum\n");
+		return -1;
+	}
+	return 0;
+}
+
+int au_check_header_valid(int idx, long nbytes)
+{
+	image_header_t *hdr;
+	unsigned long checksum;
+
+	hdr = (image_header_t *)VALID_ADDR;
+	/* check the easy ones first */
+#undef CHECK_VALID_DEBUG
+#ifdef CHECK_VALID_DEBUG
+	printf("magic %#x %#x ", ntohl(hdr->ih_magic), IH_MAGIC);
+	printf("arch %#x %#x ", hdr->ih_arch, IH_ARCH_ARM);
+	printf("size %#x %#lx ", ntohl(hdr->ih_size), nbytes);
+	printf("type %#x %#x ", hdr->ih_type, IH_TYPE_KERNEL);
+#endif
+	if (nbytes < sizeof(*hdr)) {
+		printf ("Image %s bad header SIZE\n", aufile[idx]);
+		return -1;
+	}
+	if (ntohl(hdr->ih_magic) != IH_MAGIC || hdr->ih_arch != IH_ARCH_ARM) {
+		printf ("Image %s bad MAGIC or ARCH\n", aufile[idx]);
+		return -1;
+	}
+	/* check the hdr CRC */
+	checksum = ntohl(hdr->ih_hcrc);
+	hdr->ih_hcrc = 0;
+
+	if (crc32 (0, (uchar *)hdr, sizeof(*hdr)) != checksum) {
+		printf ("Image %s bad header checksum\n", aufile[idx]);
+		return -1;
+	}
+	hdr->ih_hcrc = htonl(checksum);
+	/* check the type - could do this all in one gigantic if() */
+	if ((idx == IDX_FIRMWARE) && (hdr->ih_type != IH_TYPE_FIRMWARE)) {
+		printf ("Image %s wrong type\n", aufile[idx]);
+		return -1;
+	}
+	if ((idx == IDX_KERNEL) && (hdr->ih_type != IH_TYPE_KERNEL)) {
+		printf ("Image %s wrong type\n", aufile[idx]);
+		return -1;
+	}
+
+	/* recycle checksum */
+	checksum = ntohl(hdr->ih_size);
+	/* for kernel and app the image header must also fit into flash */
+	if (idx != IDX_FIRMWARE)
+		checksum += sizeof(*hdr);
+	/* check the size does not exceed space in flash. HUSH scripts */
+	/* all have ausize[] set to 0 */
+	if ((ausize[idx] != 0) && (ausize[idx] < checksum)) {
+		printf ("Image %s is bigger than FLASH\n", aufile[idx]);
+		return -1;
+	}
+	return 0;
+}
+
+void decrypt(char * addr, int nbytes)
+{
+	int i;
+
+	for (i = 0; i < nbytes; i++) {
+		*addr++ ^= 0xE3;
+	}
+}
+
+int au_do_update(int idx, char * address)
+{
+	image_header_t *hdr;
+	unsigned int start, end;
+	char *addr;
+	int off=0;
+	int rc=0;
+	unsigned int nbytes;
+	char argv0[20];
+	char argv1[20];
+	char argv2[20];
+	char argv3[20];
+	char argv4[20];
+	off=off;
+
+	hdr = (image_header_t *)address;
+
+	start = aufl_layout[idx].start;
+	end = aufl_layout[idx].end;
+
+	/* unprotect the address range */
+	/* this assumes that ONLY the firmware is protected!
+	   if (idx == IDX_FIRMWARE) {
+	   flash_sect_protect(0, AU_FL_FIRMWARE_ST, aufl_layout[idx+1].start-1);
+	   }
+	   */
+
+	/*
+	 * erase the address range.
+	 */
+	/* Add By River 12.16.2008 */
+	switch( hdr->ih_type )
+	{
+		case IH_TYPE_FIRMWARE:
+			//			fpc_init_show("E.Ub");
+			break;
+
+		case IH_TYPE_KERNEL:
+			//			fpc_init_show("E.uI");
+			break;
+
+		case IH_TYPE_RAMDISK:
+			//			fpc_init_show("E.FS");
+			break;
+
+		default:
+			break;
+	}
+	debug ("flash_sect_erase(%lx, %lx);\n", start, end);
+
+	/*--------------------------------------------------------------------*/
+	/* 20091021 River's suggestion                                        */
+	/*--------------------------------------------------------------------*/
+
+	if(( hdr->ih_type == IH_TYPE_KERNEL )||( hdr->ih_type == IH_TYPE_RAMDISK ))
+	{
+		sprintf( argv0, "%s", "nand" );
+		sprintf( argv1, "%s", "erase" );
+		sprintf( argv2, "%X", start );
+		sprintf( argv3, "%X", end-start );
+
+		char *argv[] = {
+			argv0,
+			argv1,
+			argv2,
+			argv3
+		};
+
+		printf("running:%s %s %s %s\n", argv0, argv1, argv2, argv3);
+		rc = do_nand( NULL, 0, sizeof(argv)/sizeof(char *), argv );
+		printf ("nand erase %X %X finished!\n",start,end-start);
+	}
+	/* Modify By River 27.04.2009 */
+	else if( hdr->ih_type == IH_TYPE_FIRMWARE )
+	{
+		sprintf( argv0, "%s", "sfer" );
+		sprintf( argv1, "%x", start );
+		sprintf( argv2, "%x", end-start );
+
+		char *argv[] = {
+			argv0,
+			argv1,
+			argv2
+		};
+		printf("running:%s %s %s\n", argv0, argv1, argv2);
+		rc = do_sflasher( NULL, 0, sizeof(argv)/sizeof(char *), argv );
+		printf ("spi flash erase finished!\n");
+	}
+	/*--------------------------------------------------------------------*/
+
+
+	mdelay(100);
+	/* strip the header for the U-boot */
+	if (hdr->ih_type != IH_TYPE_KERNEL) {
+		addr = (char *)((char *)hdr + sizeof(*hdr));
+		off = 0;
+		nbytes = ntohl(hdr->ih_size);
+	} else {
+		addr = (char *)hdr;
+		off = sizeof(*hdr);
+		nbytes = sizeof(*hdr) + ntohl(hdr->ih_size);
+	}
+
+	/* copy the data from RAM to FLASH */
+	/* Add By River 12.16.2008 */
+	switch( hdr->ih_type )
+	{
+		case IH_TYPE_FIRMWARE:
+			//			fpc_init_show("P.Ub");
+			break;
+
+		case IH_TYPE_KERNEL:
+			//			fpc_init_show("P.uI");
+			break;
+
+		case IH_TYPE_RAMDISK:
+			//			fpc_init_show("P.FS");
+			break;
+
+		default:
+			break;
+	}
+
+
+	if(( hdr->ih_type == IH_TYPE_KERNEL )||( hdr->ih_type == IH_TYPE_RAMDISK ))
+	{
+		sprintf( argv0, "%s", "nand" );
+		sprintf( argv1, "%s", "write.jffs2" );
+		sprintf( argv2, "%x", (unsigned int)addr );
+		sprintf( argv3, "%x", start );
+		sprintf( argv4, "%x", nbytes );
+		char *argv[] = {
+			argv0,
+			argv1,
+			argv2,
+			argv3,
+			argv4
+		};
+		printf("running:%s %s %s %s %s\n", argv0, argv1, argv2, argv3, argv4);
+		rc = do_nand( NULL, 0, sizeof(argv)/sizeof(char *), argv );
+	}
+	if(hdr->ih_type == IH_TYPE_FIRMWARE)
+	{
+		sprintf( argv0, "%s", "sfwr" );
+		sprintf( argv1, "%x", (unsigned int)addr );
+		sprintf( argv2, "%x", start );
+		sprintf( argv3, "%x", nbytes );
+		char *argv[] = {
+			argv0,
+			argv1,
+			argv2,
+			argv3
+		};
+		printf("running:%s %s %s %s\n", argv0, argv1, argv2, argv3);
+		rc = do_sflashwr( NULL, 0, sizeof(argv)/sizeof(char *), argv );
+	}
+	else
+	{
+		printf("flash_write(%p, %x %x)\n", addr, start, nbytes);
+		debug ("flash_write(%p, %x %x)\n", addr, start, nbytes);
+		/* rc = flash_write(addr, start, nbytes);*/
+	}
+	printf("flash write finished!\n");
+	if (rc != 0) {
+		printf("Flashing failed due to error %d\n", rc);
+		return -1;
+	}
+
+	/* check the dcrc of the copy
+	   if (crc32 (0, (uchar *)(start + off), ntohl(hdr->ih_size)) != ntohl(hdr->ih_dcrc)) {
+	   printf ("Image %s Bad Data Checksum After COPY\n", aufile[idx]);
+	   return -1;
+	   }
+	   */
+
+	/* protect the address range */
+	/* this assumes that ONLY the firmware is protected!
+	   if (idx == IDX_FIRMWARE)
+	   flash_sect_protect(1, AU_FL_FIRMWARE_ST, aufl_layout[idx+1].start-1);
+	   */
+	return 0;
+}
+
+/*
+ * this is called from board_init() after the hardware has been set up
+ * and is usable. That seems like a good time to do this.
+ * Right now the return value is ignored.
+ */
+int do_auto_update(unsigned int size)
+{
+	block_dev_desc_t *stor_dev;
+	long sz;
+	int i, j, res=0, bitmap_first=0, old_ctrlc;
+	//char *env;
+	long start, end;
+	long actual_size=0;
+	image_header_t *hdr;
+	char * addr;
+	char st[9], len[9];
+	char *ptr = (char *)CONFIG_USB_UPGRADE_DATA_ADDR;
+	char *ep;
+	char *bootargs = NULL;
+	char *bootcmd = NULL;
+	actual_size=actual_size;
+	bitmap_first=bitmap_first;
+	res=res;
+	/* initialize the array of file names */
+	memset(aufile, 0, sizeof(aufile));
+	aufile[IDX_FIRMWARE] = AU_FIRMWARE;
+	aufile[IDX_KERNEL] = AU_KERNEL;
+	aufile[IDX_RAMDISK] = AU_RAMDISK;
+	/* initialize the array of flash sizes */
+	memset(ausize, 0, sizeof(ausize));
+	/* make sure that we see CTRL-C and save the old state */
+	old_ctrlc = disable_ctrlc(0);
+
+	if(!size){
+		au_usb_stor_curr_dev = -1;
+		/* start USB */
+		if (usb_stop() < 0) {
+			debug ("usb_stop failed\n");
+			return -1;
+		}
+		if (usb_init() < 0) {
+			debug ("usb_init failed\n");
+			return -1;
+		}
+
+		/*
+		 * check whether a storage device is attached (assume that it's
+		 * a USB memory stick, since nothing else should be attached).
+		 */
+		au_usb_stor_curr_dev = usb_stor_scan(0);
+		if (au_usb_stor_curr_dev == -1) {
+			debug ("No device found. Not initialized?\n");
+			return -1;
+		}
+
+		//		fpc_init_show("Upda");	/* Add By River 12.16.2008 */
+
+		/* check whether it has a partition table */
+		stor_dev = get_dev("usb", 0);
+		if (stor_dev == NULL) {
+			debug ("uknown device type\n");
+			return -1;
+		}
+		if (fat_register_device(stor_dev, 1) != 0) {
+			debug ("Unable to use USB %d:%d for fatls\n",
+					au_usb_stor_curr_dev, 1);
+			return -1;
+		}
+		if (file_fat_detectfs() != 0) {
+			debug ("file_fat_detectfs failed\n");
+		}
+
+		/*
+		 * now check whether start and end are defined using environment
+		 * variables.
+		 */
+		/*start = -1;
+		  end = 0;
+		  env = getenv("firmware_st");
+		  if (env != NULL)
+		  start = simple_strtoul(env, NULL, 16);
+		  env = getenv("firmware_nd");
+		  if (env != NULL)
+		  end = simple_strtoul(env, NULL, 16);
+		  if (start >= 0 && end && end > start) {
+		  ausize[IDX_FIRMWARE] = (end + 1) - start;
+		  aufl_layout[0].start = start;
+		  aufl_layout[0].end = end;
+		  }
+		  start = -1;
+		  end = 0;
+		  env = getenv("kernel_st");
+		  if (env != NULL)
+		  start = simple_strtoul(env, NULL, 16);
+		  env = getenv("kernel_nd");
+		  if (env != NULL)
+		  end = simple_strtoul(env, NULL, 16);
+		  if (start >= 0 && end && end > start) {
+		  ausize[IDX_KERNEL] = (end + 1) - start;
+		  aufl_layout[1].start = start;
+		  aufl_layout[1].end = end;
+		  }
+		  start = -1;
+		  end = 0;
+		  env = getenv("ramdisk_st");
+		  if (env != NULL)
+		  start = simple_strtoul(env, NULL, 16);
+		  env = getenv("ramdisk_nd");
+		  if (env != NULL)
+		  end = simple_strtoul(env, NULL, 16);
+		  if (start >= 0 && end && end > start) {
+		  ausize[IDX_KERNEL] = (end + 1) - start;
+		  aufl_layout[2].start = start;
+		  aufl_layout[2].end = end;
+		  }*/
+		/* make certain that HUSH is runnable */
+		u_boot_hush_start();
+
+		bitmap_first = 0;
+		// the first byte is the string length of bootargs
+
+		//		fpc_init_show("Read");	/* Add By River 12.16.2008 */
+
+		sz = file_fat_read(filename, (void*)(CONFIG_USB_UPGRADE_DATA_ADDR), 0);
+		if (sz <= 0) {
+			debug ("file %s not found\n", filename);
+			return -1;
+		}
+	}else{
+		size -= 256;
+		sz = size;
+		printf("Upgrade directly from RAM: 0x%08x, size = 0x%08x\n", (unsigned int)CONFIG_USB_UPGRADE_DATA_ADDR,(unsigned int) sz);
+	}
+
+	//	dcache_enable();
+
+	decrypt((char *)CONFIG_USB_UPGRADE_DATA_ADDR, sz);
+	bootargs_len = (*ptr << 8) | (*(ptr+1));
+	printf("bootargs_len = %d\n",bootargs_len);
+	ptr +=2;
+	bootcmd_len = (*ptr << 8) | (*(ptr+1));
+	printf("bootcmd_len = %d\n",bootcmd_len);
+	bootargs = malloc(bootargs_len + 1);
+	memcpy( (void*) bootargs, (void*) ( CONFIG_USB_UPGRADE_DATA_ADDR + 4) , bootargs_len);
+	bootargs[bootargs_len] = '\0';
+	printf("[bootargs]: %s\n", bootargs);
+	bootcmd = malloc(bootcmd_len + 1);
+	memcpy(bootcmd, (void*)( CONFIG_USB_UPGRADE_DATA_ADDR + 4 + bootargs_len), bootcmd_len);
+	bootcmd[bootcmd_len] = '\0';
+	printf("[bootcmd]: %s\n", bootcmd);
+
+	ptr = (char*) ( CONFIG_USB_UPGRADE_DATA_ADDR + 4 + bootargs_len + bootcmd_len );
+	for (i = 0; i < 3; i++) {
+		for(j = 0; j < 8; j++) {
+			st[j] = *ptr++;
+		}
+		st[j] = '\0';
+		for(j = 0; j < 8; j++) {
+			len[j] = *ptr++;
+		}
+		len[j] = '\0';
+
+		start = simple_strtoul(st, &ep, 16);
+		if (ep == st || *ep != '\0') {
+			printf("simple_strtoul return error!\n");
+			return -1;
+		}
+
+		end = simple_strtoul(len, &ep, 16);
+		if (ep == st || *ep != '\0') 
+		{
+			printf("simple_strtoul return error!\n");
+			return -1;
+		}
+		if (end == 0)
+			continue;
+
+		if (start >= end) {
+			printf("Start address beyond end address\n");
+			return -1;
+		}
+		ausize[i] = (end + 1) - start;
+		aufl_layout[i].start = start;
+		aufl_layout[i].end = end;
+		printf("%s: 0x%lX--0x%lX\n", aufile[i], aufl_layout[i].start, aufl_layout[i].end);
+	}
+
+	hdr = (image_header_t *)(VALID_ADDR);
+	actual_size = ntohl(hdr->ih_size);
+	if (au_check_cksum_valid(sz) < 0) {
+		debug ("%s checksum not valid\n", filename);
+		return -1;
+	}
+
+	//	dcache_disable();
+	addr = (char*) (VALID_ADDR + sizeof(image_header_t) );
+	/* just loop thru all the possible files */
+	for (i = 0; i < AU_MAXFILES; i++) {
+		hdr = (image_header_t *)addr;
+		if (hdr->ih_type == autype[i] && hdr->ih_os == ostype[i]) {
+			res = au_do_update(i, addr);
+			addr += (sizeof(image_header_t) + ntohl(hdr->ih_size));
+		}
+	}
+
+	if (bootargs_len != 0){
+		setenv("bootargs", bootargs);
+	}
+	if (bootcmd_len != 0){
+		setenv("bootcmd", bootcmd);
+	}
+	if ((bootargs_len != 0) || (bootcmd_len != 0)){
+		int i = 0;
+		for(i = 0; i< 500; i++)
+			udelay(1000);
+		saveenv();
+	}
+
+	free(bootargs);
+	free(bootcmd);
+
+	usb_stop();
+	/* restore the old state */
+	disable_ctrlc(old_ctrlc);
+
+	//	fpc_init_show("rebt");	/* Add By River 12.16.2008 */
+	//while(1){};
+#ifdef RESET_AFTER_USB_UPGRADE
+	do_reset( NULL, 0, 0, NULL );
+#endif
+	return 0;
+}
+#endif /* CONFIG_AUTO_UPDATE */
+
diff '--exclude=.svn' -Naur u-boot-2011.06_original/board/cavium/cnc1900/cnc1900.c u-boot-2011.06/board/cavium/cnc1900/cnc1900.c
